<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "account_contact_setting".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "AccountDeviceHistory".
 *
 * Columns in table "account_contact_setting" available as properties of the model,
 * followed by relations of table "account_contact_setting" available as properties of the model.
 *
 * @property string $id
 * @property integer $account_contact_id
 * @property int $practice_id
 * @property int $provider_id
 *
 * @property AccountContact $accountContact
 */
abstract class BaseAccountContactSetting extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'account_contact_setting';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'AccountContactSetting|AccountContactSettingd', $n);
    }

    public static function representingColumn()
    {
        return '';
    }

    public function rules()
    {
        return array(
            array('account_contact_id', 'required'),
            array('account_contact_id, practice_id, provider_id', 'numerical', 'integerOnly' => true),
            array('practice_id, provider_id', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, account_contact_id, practice_id, provider_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'accountContact' => array(self::BELONGS_TO, 'AccountContact', 'account_contact_id'),
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'account_contact_id' => null,
            'practice_id' => Yii::t('app', 'Practice'),
            'provider_id' => Yii::t('app', 'Provider'),
            'accountContact' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id, true);
        $criteria->compare('account_contact_id', $this->account_contact_id);
        $criteria->compare('practice_id', $this->practice_id, true);
        $criteria->compare('provider_id', $this->provider_id, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }
}
